﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.C1Preview;

namespace OlapReports
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            // load data
            var da = new OleDbDataAdapter("select * from invoices", GetConnectionString());
            var dt = new DataTable();
            da.Fill(dt);
            this.c1OlapPage1.DataSource = dt;

            // load view definition
            this.c1OlapPage1.ViewDefinition = Properties.Resources.ViewDefinition;
        }

        static string GetConnectionString()
        {
            string path = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + @"\ComponentOne Samples\Common";
            string conn = @"provider=microsoft.jet.oledb.4.0;data source={0}\c1nwind.mdb;";
            return string.Format(conn, path);
        }
        DataTable GetOlapDataTable()
        {
            // clone OLAP table
            var dt = this.c1OlapPage1.OlapEngine.OlapTable.Clone();
            dt.Merge(this.c1OlapPage1.OlapEngine.OlapTable);

            // add row information to output table
            var dc = dt.Columns.Add("{RowInformation}", typeof(string));
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                var dr = this.c1OlapPage1.OlapEngine.OlapTable.Rows[i];
                var key = this.c1OlapPage1.OlapEngine.GetOlapKey(dr);
                dt.Rows[i][dc] = key.ToString();
            }

            // done
            return dt;
        }
        void SaveOlapData(string fileName)
        {
            // save to XML file (can be used as a data source in the report designer)
            var ds = new DataSet();
            ds.Tables.Add(GetOlapDataTable());
            ds.WriteXml(fileName, XmlWriteMode.WriteSchema);
            ds.Tables.Clear();
        }
        void button1_Click(object sender, EventArgs e)
        {
            // save OLAP data to a file
            var fileName = Path.Combine(Application.StartupPath, "olap.xsd");
            SaveOlapData(fileName);
        }
        void button2_Click(object sender, EventArgs e)
        {
            // Method 1: save data to a file, load it back, assign to report
            // save OLAP data to a file
            // var fileName = Path.Combine(Application.StartupPath, "olap.xsd");
            // SaveOlapData(fileName);

            // assign data source to report
            // DataSet ds = new DataSet();
            // ds.ReadXml(Path.Combine(Application.StartupPath, "olap.xsd"));
            // c1Report1.DataSource.Recordset = ds.Tables[0];

            // Method 2: assign OlapPage output table directly to report's data source          
            c1Report1.DataSource.Recordset = GetOlapDataTable();
            
            //launch print preview dialog
            C1PrintPreviewDialog dg = new C1PrintPreviewDialog();
            dg.Text = "Print Preview";
            dg.Document = c1Report1;
            dg.Show();

            // export to pdf file
            //var fileName = Path.Combine(Application.StartupPath, "olap.pdf");
            //c1Report1.RenderToFile(fileName, C1.C1Report.FileFormatEnum.PDF);

            // show pdf file
            //System.Diagnostics.Process.Start(fileName);
        }
    }
}
